<?php
/*
Plugin Name: Smart Unread Comments
Version: 1.3
Plugin URI: http://inner.geek.nz/wordpress-plugins/smart-unread-comments/
Description: Displays a list of posts with comments unread by the user.  Uses cookies to track read comments.  Based on code by Chris Beaven.
Author: Brett Taylor
Author URI: http://inner.geek.nz/wordpress-plugins/
*/
// execute cookies stuff before output!
add_action('template_redirect', 'wbft_suc_set_recent_posts_timeout', 9);
add_action('template_redirect', 'wbft_suc_set_recent_posts_cookie', 10);

function wbft_suc_set_recent_posts_timeout() {
	if (isset($_GET['posts_timeout'])) {
		$time = strtotime(gmdate('Y-m-d H:i:s')) + get_settings('gmt_offset') * 3600;
		$timeout = 3600*24*14;
		$cookiepath = parse_url(get_bloginfo('wpurl'));
		if ($cookiepath['path'] == "") {
			$cookiepath['path'] = "/";
		}
		setcookie("posts_timeout", $time, $time+$timeout, $cookiepath['path']);
		if($_SERVER['HTTP_REFERER']) {
			header("Location: ".$_SERVER['HTTP_REFERER']);
			exit();
		}
	}
}

// returns an array
function wbft_suc_get_recent_posts() {
	$db =& $GLOBALS['wpdb'];
	$cookie = $_COOKIE['recentposts'];
	// if it's empty, return an empty array
	if (!$cookie)
		return array();
	// make it back into an array
	$recent_posts = unserialize($cookie);
	$recent_posts_new = array();
	$timeout = 3600*24*14;
	$time = time() + get_settings('gmt_offset') * 3600;
	$current_timeout = $time - $timeout;
	// go through and strip out any posts without comments in the last 14 days so we don't get a giant cookie
	foreach ($recent_posts as $postid => $posttime) {
		$sql = "SELECT comment_date FROM ".$GLOBALS['tablecomments']." WHERE comment_date > FROM_UNIXTIME(".$current_timeout.") AND comment_post_ID = ".$postid." AND comment_approved = '1' ORDER BY comment_date DESC LIMIT 1";
		$rs = $db->get_results($sql);
		if ($rs === false) {
			die( $wpdb->ErrorMsg());
		}
		if ($rs[0]->comment_date) {
			$recent_posts_new[$postid] = $posttime;
		}
	}
	return $recent_posts_new;
}
function wbft_suc_set_recent_posts_cookie() {
	global $wp_query;
	$db =& $GLOBALS['wpdb'];
    if(is_single() /* || is_page() */) {
	//if (isset($_GET['p'])) {
		$postid = $wp_query->post->ID;
		//$postid = $_GET['p'];
		$timeout = 3600*24*14;
		$time = strtotime(gmdate('Y-m-d H:i:s')) + get_settings('gmt_offset') * 3600;
		$current_timeout = $_COOKIE['posts_timeout'];
		if (!$current_timeout) {
			$current_timeout = $time - $timeout;
		}
		$sql = "SELECT comment_date FROM ".$GLOBALS['tablecomments']." WHERE comment_date > FROM_UNIXTIME(".$current_timeout.") AND comment_post_ID = ".$postid." AND comment_approved = '1' ORDER BY comment_date DESC LIMIT 1";
		$rs = $db->get_results($sql);
		if ($rs === false) {
			die( $db->ErrorMsg());
		}
		if ($rs[0]->comment_date) {
			// there was a recent comment, so let's set the cookie
			$recent_posts = wbft_suc_get_recent_posts();
			$recent_posts[$postid] = $time;

			$cookiepath = parse_url(get_bloginfo('wpurl'));
			if ($cookiepath['path'] == "") {
				$cookiepath['path'] = "/";
			}
			setcookie("recentposts", serialize($recent_posts), $time+$timeout, $cookiepath['path']);
		}
	}
}

function get_smart_unread_comments($limit = 5, $output_when_no_unread_comments = true, $output_when_more_unread_comments_than_limit = true, $mark_comments_as_read_text = "Mark all comments as read", $no_unread_comments_text = "There are no unread comments", $more_unread_comments_text = "There are %d more unread comments...") {
	global $wp_query;
	if (is_single()) {
		$currentpostid = $postid = $wp_query->post->ID;
		//echo "postid: ".$currentpostid."<br />";
	}
	/*
	echo "wpurl: <pre>".print_r(parse_url(get_bloginfo('wpurl')),true)."</pre><br />";
	echo "recentposts: <pre>";
	print_r(wbft_suc_get_recent_posts());
	echo "</pre><br />";
	echo "recentposts cookie: <pre>";
	print_r(unserialize($_COOKIE['recentposts']));
	echo "</pre><br />";
	echo "posts_timeout cookie: <pre>";
	print_r($_COOKIE['posts_timeout']);
	echo "</pre><br />";
	*/
	$db =&$GLOBALS['wpdb'];
	$timeout = 3600*24*14;
	$time = strtotime(gmdate('Y-m-d H:i:s')) + get_settings('gmt_offset') * 3600;
	$current_timeout = $_COOKIE['posts_timeout'];
	if (!$current_timeout) {
		$current_timeout = $time - $timeout;
	}
	$sql = "SELECT ID, post_title, comment_author, comment_date, comment_date_gmt, comment_id";
	$sql .= " FROM ".$GLOBALS['tableposts']." INNER JOIN ".$GLOBALS['tablecomments']." ON ".$GLOBALS['tableposts'].".ID = ".$GLOBALS['tablecomments'].".comment_post_ID";
	$sql .= " WHERE comment_date > FROM_UNIXTIME(".$current_timeout.") AND comment_approved = '1'";
	$sql .= " ORDER BY comment_date DESC";
	$resultset = $db->get_results($sql);
	$recent_posts = wbft_suc_get_recent_posts();
	if ($resultset === false) {
		die( "Error");
	}
	$output = "";
	$posts = array();
	$counter = 0;
	while (count($posts) <= $limit && $data = $resultset[$counter]) {
		$counter++;
		$post_id = $data->ID;
		$post_title = $data->post_title;
		$comment_author = $data->comment_author;
		$comment_date = $data->comment_date;
		$comment_date_gmt = $data->comment_date_gmt;
		$comment_id = $data->comment_id;
		$post = $posts[$post_id];
		$cookie_time = $recent_posts[$post_id];
		if (!$cookie_time) {
			$cookie_time = $current_timeout;
		}
		// if it's a recent comment and it's not the post we could be looking at...
		if (strtotime($comment_date) > $cookie_time && (!isset($currentpostid) || ($currentpostid != $post_id))) {
			if (!$post) {
				$posts[$post_id] =
					array('comment_date' => $comment_date,
						  'comment_author' => $comment_author,
						  'comment_count' => 1,
						  'post_title' => $post_title,
						  'post_id' => $post_id,
						  'comment_id' => $comment_id);
			} else {
				$post['comment_count']++;
				if ($comment_id < $post['comment_id'] ) {
					$posts[$post_id] =
					array('comment_date' => $comment_date,
						  'comment_author' => $comment_author,
						  'comment_count' => $post['comment_count'],
						  'post_title' => $post_title,
						  'post_id' => $post_id,
						  'comment_id' => $comment_id);
				}
			}
		}
	}
	$posts = array_values($posts);
	sort($posts);
	$posts = array_reverse($posts);
	$postcount = count($posts);
	while (count($posts) > $limit) {
		array_pop($posts);
	}
	reset($posts);
	$output = "";
	foreach ($posts as $post) {
		if ($time - strtotime($post['comment_date']) < (3600*6)) {
			$style = " class='wbftSUC_Recent'";
		}
		$output .= "\n\t<li".$style."><a href='".get_permalink($post['post_id'])."' title='".$post['comment_date'].", ".$post['comment_author']."'>".$post['post_title']."</a>&nbsp;(<a href='".get_permalink($post['post_id'])."#comment-".$post['comment_id']."' title='Oldest unread recent comment for this post'>".$post['comment_count']."</a>)</li>";
	}
	if ($posts) {
		if ($output_when_more_unread_comments_than_limit && $postcount > $limit) {
			$output .= sprintf("\n<li class='wbftSUC_MoreComments'>".$more_unread_comments_text."</li>", $postcount - $limit);
		}
		$output .= "\n\t<li class='wbftSUC_MarkAsRead'><a href='".get_bloginfo('wpurl')."?posts_timeout=1'>".$mark_comments_as_read_text."</a></li>";
	} elseif ($output_when_no_unread_comments) {
		$output = "<li class='wbftSUC_NoComments'>".$no_unread_comments_text."</li>";
	}
	return stripslashes($output);
}
?>
